%% Plotting in R

%% Based on the rnw file plottingInR.Rnw
%% Header information removed to allow compilation as single report
%% Last updated the file from Rnw before copying on 2014/May/14

%% Keep from here down

\chapter[Plotting in R]{Plotting in R}




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Background} %%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

When starting out with statistics and data analysis,
you may have calculated many statistics by hand,
possibly with a calculator or spreadsheet.
%
By-hand calculations are a great starting point to understand basic concepts
and acquaint yourself with data analysis.
%
However, as data sets grow larger and statistical questions grow more complex,
being able to run your analyses in a computer program will become increasingly important.
%
Here, we are going to explore one of these tools:
R, a statistics environment designed to be a fully operational programming language. 


This tutorial is going to focus primarily on how to \emph{run} analyses,
rather than what they mean.
%
Throughout, there are questions related to interpretation of the outputs,
asking you to state what you think is going on in the data.
%
In these places,
please refer to other sources, such as
a statistics text,
materials from a statistics course,
or Wikipedia,
which has fantastic descriptions of many statistical concepts and tests.
%
In this chapter,
we will work through some simple examples of data manipulation and plotting,
slowly building your repertoire and confidence.


\subsection{Why R?}

R was designed with high quality graphics explicitly in mind,
which makes the default plots it produces elegant
while allowing users full control over the outputs.
%
In addition,
this flexibility extends to the handling and display of raw data,
making it possible to store, manipulate,
and analyze a wide variety of data types in a single program.
%
This flexibility comes at the cost of a large learning curve,
especially as many of you are probably new to computer programming.
%
Finally, R is free, both free as in beer (no cost)
and free as in speech 
(the source code is available,
can be manipulated, and can run on any platform),
making it an accessible choice for students and researchers.



RStudio provides a useful wrapper for R -
it allows us to save what we are doing each step of the way,
and displays useful information
(graphs, help files, etc.)
alongside our progress.
%
For all of our activities,
we will be working in RStudio.
%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Chapter Goals} %%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{itemize}
\item How to install and utilize a statistical package
\item Be able to import data into R
\item Be able to graphically represent your data
\item How to comfortably approach command line and computer code problems
\end{itemize}

\section{Installing R and RStudio}

Below are basic instructions for installing R and RStudio,
on each
\hyperref[subsec:installLinux]{linux},
\hyperref[subsec:installMac]{Mac}, and
\hyperref[subsec:installWindows]{Windows}.
%
However, you can vist
\href{http://cran.r-project.org/bin}{http://cran.r-project.org/bin}
for more details on the installation of R and \\
\href{http://www.rstudio.com/ide/download/desktop}{http://www.rstudio.com/ide/download/desktop}
for information on RStudio.


\subsection{Install in Linux}
\label{subsec:installLinux}

To install R on a Linux distribution,
there are two main approaches.
%
You can either download precompiled binaries for your specific installation,
or compile yourself from source code.
%
Binaries (which I recommend for most users)
and information on how to install them are available at:
\url{http://lib.stat.cmu.edu/R/CRAN/bin/linux/}.
%
% I highly recommend installing these binaries.

% To compile R from source,
% download the latest version
% (R-3.1.0.tar.gz as of this writing) from \\
% \url{http://lib.stat.cmu.edu/R/CRAN/}.
% %
% Untar the file (tar -xzvf R-3.1.0.tgz) and cd into the resulting directory.
% %
% Now run:
% \begin{knitrout}
% \begin{kframe}
% ./configure
% 
% make
% 
% make check
% 
% sudo make install
% \end{kframe}
% \end{knitrout}

RStudio binaries are available for Fedora and Ubuntu/Debian.
Copy the current link for your system (examples below) from
\url{http://www.rstudio.com/ide/download/desktop},
and install with either
of the below (for Fedora or Debian respectively):

\begin{knitrout}\begin{kframe}\begin{alltt}
sudo yum install http://download1.rstudio.org/rstudio-0.97.551-x86\_64.rpm

sudo apt-get install http://download1.rstudio.org/rstudio-0.97.551-amd64.deb
\end{alltt}\end{kframe}\end{knitrout}


%

Alternatively, a tarball of the source code is available
for both R and RStudio at their respective download pages,
if you prefer to install from source.


\subsection{Install on Mac}
\label{subsec:installMac}

In Mac, download the current version of R from 
\url{http://cran.r-project.org/bin/macosx/}
(currently R-3.1.0).
%
Make sure to get the version for your OS version.
%
This can be installed like other .pkg files --
double-click and follow the on screen directions.


To install Rstudio on a Mac,
download the latest .dmg RStudio file 
(currently 0.98.507)
from
\url{http://www.rstudio.com/ide/download/desktop}%
.
%
Install by mounting the .dmg file (double-click on it).
%
An app should appear in a new Finder window.
%
Drag it from the new window into your ``Applications'' folder.
%
From now on, you can open RStudio directly from your Applications.


\subsection{Install in Windows}
\label{subsec:installWindows}

In Windows,
download 
(from
\url{http://cran.r-project.org/bin/windows/base/})
the current version of R (currently R-3.1.0.exe),
and install like other .exe files:
double-click and follow the on screen directions.



RStudio for Windows can be installed by downloading the latest .exe file
(currently RStudio 0.97.551)
from
\url{http://www.rstudio.com/ide/download/desktop}%
.
%
Again, double-click and follow the on screen instructions.


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Getting Started} %%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

First, open RStudio. Then, select ``File $\rightarrow $ New $\rightarrow $ R Script'' to open a new document.
%
Save this R script file
(Either ``File $\rightarrow $ Save'' or \verb;Ctrl+s;)
in your own directory (folder)
with a file name begining with your last name.
%
As we go along, make sure to save frequently - 
there is no such thing as saving too often.
%
This document will hold all of our commands for the lesson.
%
This file will:

\begin{itemize}
\item Provide us with a record of everything we do
\item Allow assessment of your progress
\item Provide you access to previously used and learned commands
\item Allow us to fix small mistakes in long pieces of code without retyping everything
\item Give you something to turn in at the end of the lab
\end{itemize}


Now, lets start by making some notes to ourselves.
%
In R, anything that is preceded by a ``\#'' is ignored.
%
This lets us make comments,
which can be incredibly helpful if we ever need to come back to the code,
or share it with others.
%
At the end of this chapter,
you will each submit your script,
along with an additional file we will produce near the end of the lab.


A note on convention:
every command I tell you to type will look like the box below.
%
In general,
you can copy what you see below directly into your script file;
however, things in ALL-CAPS should be replaced with your information.
%
In addition, be careful with copy-paste,
as pdf files occasionally have hidden characters.
%
Make sure to run every line you copy over
(including comments; both ``comments'' and ``running'' are defined soon)
as R will throw an error if there is a hidden character,
and they are much harder to find if you try to run multiple lines at the same time
(as you will at the end of the chapter).


\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Script written by FIRSTNAME LASTNAME}
\hlcom{## Euk Genomics Class First Script}
\hlcom{## YEAR-MON-DD}
\end{alltt}\end{kframe}\end{knitrout}


This information will help to remind you of what you were doing when writing the code,
what its purpose is/was,
and when it was written.
%
Believe me,
when you come back to this to work on your projects,
you \textit{will} appreciate having these comments.
%
Comments can also help others to understand your code,
and should become a habit for you.
%
These directions will include comments throughout,
but feel free to add your own notes to the code as well.
%
Part of the grade for this assignment,
if you are doing this as part of a class,
will include your comments
and answers to questions in this document.


Now, we need to see how these commands are actually passed to R.
In RStudio, if you press \verb;Ctrl+Enter;,
it will send the highlighted text
(or current line if nothing is highlighted)
to the command line.
%
Highlight the three lines of comments
(either with the mouse,
or by holding shift and using the arrow keys)
and press \verb;Ctrl+Enter;.
%
This action sends the comments to the Console and executes any code.
%
Alternatively,
you can click ``Run`` above the script window to accomplish the same thing.
%
Here, the text is commented, so nothing happens.


Next,
we need to tell R where it should be looking for your documents,
and where it should save outputs.
%
This is similar to opening a folder,
but we need to tell R in text.
%
This is called ``setting the working directory'',
and it will be the folder in which R opens and saves any files that you use,
until you change the directory.
%
In RStudio,
this can be done from a drop-down menu.
%
Click ``Session'' $\rightarrow $ ``Set Working Directory''
$\rightarrow $ ``To Source File Location.''
%
This will set the directory to the folder in which your script file
(where you are typing commands) is located.
%
If you want to select a different directory,
click instead on ``Choose Directory.''


You will notice that a command showed up in the terminal window,
which should read something similar to:


\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Manually set working directory}
\hlcom{## Make sure that this is set for your computer, not mine}
\hlkwd{setwd}\hlstd{(}\hlstr{'\mytilde/Documents/learningR/'}\hlstd{)}
\end{alltt}\end{kframe}\end{knitrout}


Copy this line into your script, near the very top.
%
This will make it easier to load in your data,
which should be saved (and unzipped)
inside the same directory (folder) where you save your script.
%
When you set the working directory,
always put it near the very top of your script.
%
That way, if you are working on a different computer
(or sharing your script) it is easy to see (and change)
the working directory to something that works for the local computer.

\section{Entering Simple Data}

The most important thing to be able to do in any stats program is to import your data.
%
In R, there are several methods for doing so,
and we will focus on just a few of them.
%
Variables in R are very flexible
and can take many different forms.
%
Variable names must begin with a letter,
but then can be any length and can include numerals.
%
In R, an arrow, composed of a ``less than'' symbol and a dash (``<-'')
is used to assign variables. 
%
Try it with this simple example:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Store a simple variable, then display it}
\hlstd{testVariable} \hlkwb{<-} \hlnum{3}
\hlstd{testVariable}
\end{alltt}\end{kframe}\end{knitrout}


To execute the commands,
either highlight all the lines and type \verb;Ctrl+Enter;,
or place the cursor on the first line and press \verb;Ctrl+Enter; for each line.
%
The first command creates a variable,
and the last line tells the console to display it.
%
This variable can now be used just like a number.
%
Try the code below, typing it in the script,
then using \verb;Ctrl+Enter; to execute it:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Use the variable}
\hlstd{testVariable} \hlopt{+} \hlnum{6}
\hlstd{testVariable} \hlopt{*} \hlnum{4}
\end{alltt}\end{kframe}\end{knitrout}


Now, go back and change the value of the variable by changing the line assigning the variable.
%
Re-execute the assignment and all of the lines using it.
%
Note that this can allow you to re-do an analysis if your initial values change
(e.g., because of a typo, or just adding observations)
without having to re-type all of your previous commands.

\section{Entering Longer Data}

A single value is not usually very useful for statistics.
You will often have multiple observations,
and will want to keep them all together,
rather than saving each as a different variable.
%
R may have already given you a hint that it can do this.
%
When you displayed the value of \verb;testVariable;,
you likely noticed a ``[1]'' next to the value.
%
(For those with programming experience,
note that the index starts at 1, not 0.)
%
This is an ``index'' telling us that the value displayed
is the first element of that variable.
%
That is because, in R, most simple variables are stored as ``vectors.''
%
This allows us to store many values in a single variable.
%
We need to tell R that we are giving it several values to
store together using the command ``\verb;c();''.
%
Try it out with this code:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Make a test vector, then display it}
\hlstd{testVector} \hlkwb{<-} \hlkwd{c}\hlstd{(}\hlnum{1}\hlstd{,}\hlnum{3}\hlstd{,}\hlnum{4}\hlstd{,}\hlnum{6}\hlstd{,}\hlnum{8}\hlstd{,}\hlnum{10}\hlstd{,}\hlnum{15}\hlstd{)}
\hlstd{testVector}
\end{alltt}\end{kframe}\end{knitrout}


Vectors in R have some special properties,
and these properties will become very useful.
%
First, lets see how vectors handle a little bit of arithmetic:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## See how vectors respond to arithmetic}
\hlstd{testVector} \hlopt{+} \hlnum{3}
\hlstd{testVector} \hlopt{*} \hlnum{2}
\hlstd{testVector} \hlopt{+} \hlstd{testVector}
\end{alltt}\end{kframe}\end{knitrout}


What did you notice about the outputs?
%
For arguments that are only one number long,
the same procedure is applied to each element (item) of \verb;testVector;.
%
When the arguments are the same length
(have the same number of stored values) as \verb;testVector; (e.g., itself),
then the argument is applied element-for-element.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Playing with Data} %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Now that we have some sense about how these things work,
we can begin to look at the data a little more closely.
%
First, lets create a new vector with each element being
3 greater than the elements in \verb;testVector;.
%
Go back to the the first arithmetic line with \verb;testVector;,
change it to match the line below, and run it:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlstd{testVectorB} \hlkwb{<-} \hlstd{testVector} \hlopt{+} \hlnum{3}
\end{alltt}\end{kframe}\end{knitrout}


All outputs in R can be saved in this fashion,
which allows you to go back and use them later or
to perform other manipulations on them.
%
For example,
what if you only want to know what the 3rd element of \verb;testVectorB; is?
%
R allows us to do that using brackets ``[ ]'' to tell it which element we want to see.
%
Try it:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Display only the 3rd element of a vector}
\hlstd{testVectorB[}\hlnum{3}\hlstd{]}
\end{alltt}\end{kframe}\end{knitrout}


We can also use this to display only elements that meet certain criteria.
%
Let's display only the elements that are greater than 8:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Display only elements greater than 8}
\hlstd{testVectorB[testVectorB} \hlopt{>} \hlnum{8}\hlstd{]}

\hlcom{## Show how it is done:}
\hlstd{testVectorB} \hlopt{>} \hlnum{8}
\end{alltt}\end{kframe}\end{knitrout}


As you can see from the last line,
R produces a type of value called a ``logical''
that says whether or not a condition 
(here, being greater than 8)
is met.
%
When placed within brackets,
only those elements that meet the condition are displayed.
%
This is useful for displaying certain data,
but is especially important when looking at two different variables.
%
For example:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Display the value of testVectorB when testVector equals 3}
\hlcom{## Note that two '=' are used for logical tests}
\hlstd{testVectorB[testVector} \hlopt{==} \hlnum{3}\hlstd{]}
\end{alltt}\end{kframe}\end{knitrout}


As we begin to analyze the data you have generated in class,
we will have grouping variables
(e.g., categories, such as a treatment)
that can be used to split the data just like this.

Finally,
we are going to generate a plot using these two vectors.
%
In R, functions (such as \verb;c(); and \verb;plot();)
accept arguements inside a pair of parentheses.
%
Once you open a parenthesis with a ``('', 
R will keep expecting that what you have provided is a part of
the function, until you close it with a ``)''.
%
Functions accept arguments either in the order they are expected,
as we use below
(see the help for each function to see the order),
or by naming each argument followed by an equal sign and the value
(e.g. ``\verb;x = 1;'').
%
The general format for plotting is to give the x-coordinates,
followed by the y-coordinates, as follows:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Make a plot of two vectors}
\hlkwd{plot}\hlstd{(testVector, testVectorB)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-11} 

}
\end{knitrout}


There are several additional options that we can use to change the plot,
and we will explore those as we move forward with analyzing data.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Importing spreadsheet style data} %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Typing in data, as described above, works for simple datasets.
What about when you have 100 observations,
each with multiple measurements and properties?
%
You could go through and type them all as individual vectors,
but that would get cumbersome rapidly,
and leads to typos and other errors affecting your results.
%
Instead,
we can use a type of variable called a data frame
(data.frame in R)
that will keep each vector together, and reduce errors.
%
Try this:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Make a data frame out of the two testVector's, then display it}
\hlstd{testDataFrame} \hlkwb{<-} \hlkwd{data.frame}\hlstd{(testVector,testVectorB)}
\hlstd{testDataFrame}
\end{alltt}\end{kframe}\end{knitrout}


As you can see,
the rows now show which elements of each vector correspond with each other.
%
In this way,
you can see the relationship between the two vectors, and,
if one were a grouping factor (e.g., treatment),
use that relationship in your analyses.
%
However, this still involved typing in all of your data,
which is still a pain and error-prone.
%
For any large dataset,
you probably already have a spreadsheet,
and would like to be able to just use that.
%
A safe, universally compatible approach,
is to use a text based format for saving your data,
such as comma-separated values (csv).

For today, the data are available
% in the P:drive under ``Academic/petersm/biostats/compLab1/data''
from the zipped ``data'' directory associtated with this tutorial.
%
Make sure to save the zip file in the same directory as your script,
and then decompress it before continuing.
%
We will start by looking at the fastPlant data,
which gives the height of plants following growth in 
either high or low fertilizer 
and high or low light exposure.


To import data, click on ``Tools'' then ``Import Dataset'' and ``From text File.''
%
Select the file ``fastPlant.csv'' and follow the on-screen prompts.
Make sure to change the separator parameters if needed (e.g., to a comma),
and tell R that the dataset has a header row.
%
Use the preview of the data frame (in the bottom right of the window)
to make sure that the dataset is reading in correctly.
%
If necessary, name the resulting data.frame ``fastPlant'' in the top left.
%
Click import, then \emph{copy the resulting command into your script}.
%
It should look something like:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## How you would load a data set from the command line}
\hlcom{## Note that this can be relative to your working directory.}
\hlcom{## Your path may be different, and should be copied }
\hlcom{##   from the Console after going through the menus.}
\hlstd{fastPlant} \hlkwb{<-} \hlkwd{read.csv}\hlstd{(}\hlstr{"data/fastPlant.csv"}\hlstd{)}
\end{alltt}\end{kframe}\end{knitrout}


Note that,
as long as your data directory is in your working directory (set above),
you can include just the ``data/fastPlant.csv''
portion of the path,
as R will know to start in your working directory.
%
This is known as a ``relative'' path,
as it is relative to your working directory
(as opposed to an ``absolute'' path that includes the full location),
and is generally a best practice, for several reasons.
%
First, it means that if you move your data directory
(for example, if you move this directory into a directory
for past courses),
all you need to change to be able to run this script is
the \verb;setwd; line at the top.
%
Second, and more importantly,
using relative directories makes it easier to share scripts
with classmates and collaborators.
%
You'll likely notice your name in the absolute path,
and the people you share your script with will have a different name there
(or maybe a completely different path, espcially if they use a different OS).
%
By using relative directories,
only the \verb;setwd; line at the very top of the script needs to be changed,
not every line reading in data.



There are several ways to access the vectors in this data.frame, and we will explore a couple.
%
First, you can use the brackets ( `` [ ''  and `` ] '') just like for vectors.
%
Here the format is ``[row, column].'' An empty argument means ``include all'' as you can see below:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Display the third column, then the 4th row}
\hlstd{fastPlant[,}\hlnum{3}\hlstd{]}
\hlstd{fastPlant[}\hlnum{4}\hlstd{,]}

\hlcom{## Display just the 4th element of the 3rd column}
\hlstd{fastPlant[}\hlnum{4}\hlstd{,}\hlnum{3}\hlstd{]}
\end{alltt}\end{kframe}\end{knitrout}


This format works for several data types in R,
but data.frames allow the use of column names,
which makes the code much easier to follow.
%
To call a single column by name,
we can either use brackets or 
the ``\$'' symbol.
% 
Either approach produces a vector,
which can then be manipulated in the same manner as the vectors we used earlier.
%
Remember that ``tab'' can autocomplete a partially typed variable
(or show available options);
this trick also works for column names after typing a ``\$''.

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Display a column by name}
\hlstd{fastPlant}\hlopt{\$}\hlstd{Height}
\hlstd{fastPlant[,}\hlstr{'Height'}\hlstd{]}

\hlcom{## Display the heights of only fertilized plants}
\hlstd{fastPlant}\hlopt{\$}\hlstd{Height[fastPlant}\hlopt{\$}\hlstd{Fert} \hlopt{==} \hlstr{'High'}\hlstd{]}
\end{alltt}\end{kframe}\end{knitrout}


This is a great way to work with multiple datasets, and keeps things very clean.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Plotting data using fast plant results} %%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

One of R's most powerful features is its plotting ability and options.
%
The default options are a great place to start,
and they can be modified readily to produce exactly the plots that you envision.
%
To start, let's plot the height of each plant,
split by whether or not it was fertilized.
%
To do this we will use the operator ``\textasciitilde{}''
(a tilde, usually above the tab key)
to denote that we are entering a formula.
%
That is we are telling R to consider what we input as
``Response Variable \textasciitilde{} Predicting Variable(s).''
%
Try the below:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Plot the heights of plants based on fertilization}
\hlkwd{plot}\hlstd{(fastPlant}\hlopt{$}\hlstd{Height} \hlopt{\mytilde} \hlstd{fastPlant}\hlopt{$}\hlstd{Fert)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-16} 

}
\end{knitrout}


Now, look at the graph that was produced.
%
It looks rather different than our earlier plot.
%
For categorical data (called factors),
R's default is to produce box plots.
%
What if you want to plot the means and confidence interval instead?
%
You could go through and compute the values yourself and plot those,
but here we encounter another of R's powers:
user created packages.
%
These packages cover a huge range of things,
and exist for nearly anything you might like to do.
%
Here, we would like to use the function ``\verb;plotmeans;''
from the package ``\verb;gplots;''
so we need to install the additional package.
%
Copy and run the following:



\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Install a new package, make sure to follow on screen prompts. }
\hlkwd{install.packages}\hlstd{(}\hlstr{'gplots'}\hlstd{)}

\hlcom{## Load the package for use:}
\hlkwd{library}\hlstd{(gplots)}
\end{alltt}\end{kframe}\end{knitrout}

Packages only need to be installed once on each computer,
so you can now add a ``\#'' before the installation line,
to prevent it from running again
(this is called ``commenting out'' a line).
%
In the future,
you will only have to run the \verb;library; line to load the package.
%
Now, use one of the packages functions to make a new plot:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Use the plotmeans function from the new package}
\hlkwd{plotmeans}\hlstd{(fastPlant}\hlopt{\$}\hlstd{Height} \hlopt{\mytilde} \hlstd{fastPlant}\hlopt{\$}\hlstd{Fert)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-19} 

}
\end{knitrout}


This plots the mean for each group, along with the confidence intervals.
%
What if we don't want the line connecting the two groups?
%
First, we can look at the help page for \verb;plotmeans;,
which will tell us what arguments we can use (and their default values). 


\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Open help for plotmeans}
\hlopt{?}\hlstd{plotmeans}
\end{alltt}\end{kframe}\end{knitrout}


Then, we can change an argument to avoid adding those lines.

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Re run with the parameter changed}
\hlkwd{plotmeans}\hlstd{(fastPlant}\hlopt{$}\hlstd{Height} \hlopt{\mytilde} \hlstd{fastPlant}\hlopt{$}\hlstd{Fert,} \hlkwc{connect}\hlstd{=}\hlnum{FALSE}\hlstd{)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-21} 

}
\end{knitrout}


This output looks a lot better and
suggests something about the effect of fertilizer on growth.
%
Add a comment (``\verb;## comment;'') that says what this figure suggests.
%
However,
there is still more that we can learn from plots like this.
%
We actually have 4 treatment groups,
and we can display them all at once,
even though there is not currently a variable naming them explicitly.
%
We could add such a variable,
but there is actually a simpler workaround:
the function ``\verb;interaction();''.
%
Try the below code to plot the full experimental design:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Plot the full experiment}
\hlkwd{plotmeans}\hlstd{(fastPlant}\hlopt{\$}\hlstd{Height} \hlopt{\mytilde} \hlkwd{interaction}\hlstd{(fastPlant}\hlopt{\$}\hlstd{Fert,fastPlant}\hlopt{\$}\hlstd{Light,} \hlkwc{sep}\hlstd{=}\hlstr{'\textbackslash{}n'}\hlstd{),}
          \hlkwc{connect}\hlstd{=}\hlnum{FALSE}\hlstd{)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-22} 

}
\end{knitrout}


This plots the four groups (a 2x2 interaction) separately,
again with mean and confidence interval bars.
%
What does this plot suggest about the treatment?
%
Add a comment with your answer.
%
A few notes are useful here.
%
First, notice that we are able to use a
function within a function to provide us with a different input -
this is an important feature of R that can really help keep code readable.
%
Second, note the ``sep= '\textbackslash{}n' '' in the function.
%
This tells the program to separate the two factors (\verb;Fert; and \verb;Light;) with a newline.
%
You can use any separator you would like,
but the newline tends to work best for plotting like this.
%
Finally, the plot is a bit messy still.
%
You can control a number of parameters to clean this up.
%
Open the help, then add a couple parameters to improve the plot.
%
I will leave the specifics up to you:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Open the help, then make the plot prettier}
\hlopt{?}\hlstd{plotmeans}
\hlkwd{plotmeans}\hlstd{(fastPlant}\hlopt{\$}\hlstd{Height} \hlopt{\mytilde} \hlkwd{interaction}\hlstd{(fastPlant}\hlopt{\$}\hlstd{Fert,fastPlant}\hlopt{\$}\hlstd{Light,}\hlkwc{sep}\hlstd{=}\hlstr{'\textbackslash{}n'}\hlstd{),}
          \hlkwc{connect}\hlstd{=}\hlnum{FALSE}\hlstd{,} \hlkwc{main}\hlstd{=} \hlstr{'TITLE FOR YOUR PLOT'}\hlstd{,}
          \hlkwc{xlab}\hlstd{=} \hlstr{'Treatment Groups (Fert; Light)'}\hlstd{,} \hlkwc{ylab}\hlstd{=} \hlstr{'Height (UNITS)'}\hlstd{)}
\end{alltt}\end{kframe}\end{knitrout}
%% Omitting the plot
% {\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-23} }


Note: in this document, continued lines will be indented as above.
%
In RStudio, the line can continue to the right effectively indefinitely.
%
If you would like to, you can add line breaks manually,
and RStudio should indent appropriately.
%
If you use multiple lines,
remember that you need to run the full command,
not just individual lines.
%
Feel free to modify any other parameters that you would like as well.
%
Just make sure that the plot looks nice when it is done.


Before we move to the next dataset, lets save this plot.
%
There are two general approaches to doing this.
%
First, in the plot window, click ``Export'' then ``Save Plot as Image ...'',
name the file with your last name, and save it wherever you would likely
(probably in your working directory).
%
Alternatively, you can use the function \verb;png(); 
or any of the similar functions to directly create an image file.
%
Look at the help for \verb;png; to see which file types are available,
and what options you can set.
%
For a simple plot, the only required arguement is a file name,
though you can do things like settng the background color,
changing the size of the output file,
and setting resolution.
%
(If you prefer pdf files, there is also a \verb;pdf(); function.)
%
However, you must always remember to close the connection to the file
(known as a ``device'')
to stop adding things to that plot,
using \verb;dev.off();.
%
Try it here:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Save a plot directly}
\hlcom{## This will automatically save the plot if you run it again}
\hlkwd{png}\hlstd{(}\hlstr{'fileName.png'}\hlstd{)}
\hlkwd{plotmeans}\hlstd{(fastPlant}\hlopt{\$}\hlstd{Height} \hlopt{\mytilde} \hlkwd{interaction}\hlstd{(fastPlant}\hlopt{\$}\hlstd{Fert,fastPlant}\hlopt{\$}\hlstd{Light,}\hlkwc{sep}\hlstd{=}\hlstr{'\textbackslash{}n'}\hlstd{),}
          \hlkwc{connect}\hlstd{=}\hlnum{FALSE}\hlstd{,} \hlkwc{main}\hlstd{=} \hlstr{'TITLE FOR YOUR PLOT'}\hlstd{,}
          \hlkwc{xlab}\hlstd{=} \hlstr{'Treatment Groups (Fert; Light)'}\hlstd{,} \hlkwc{ylab}\hlstd{=} \hlstr{'Height (UNITS)'}\hlstd{)}
\hlcom{## Always turn off the device, so R knows you are done}
\hlkwd{dev.off}\hlstd{()}
\end{alltt}\end{kframe}\end{knitrout}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Looking at normality using penny ages} %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Now, we are going to switch to a new data set,
and play with a couple of other functions in R.
%
This data set has the age of 1000 pennies,
measured in years prior to the day they were collected by students.
%
For the sake of being able to find things,
I like to separate out the sections of a script with something like:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{##################################################################}
\hlcom{##################### PLAY WITH PENNY DATA #######################}
\hlcom{##################################################################}
\end{alltt}\end{kframe}\end{knitrout}


This way, it is easy to search back through your code to find a particular section.
%
You could, alternatively, create a new script.
%
However, to keep the lab all together, let's not.
%
Now, we are going to read in the penny data,
just like we did with the fast plant data.
%
Either,
go to ``Tools'' then ``Import Dataset'' and ``From text File''
or try typing it directly, as listed below.
%
Note that in RStudio,
hitting `tab' will auto-complete many commands,
variable name, and even the path to files.
%
If you use the menus,
make sure to change parameters (including setting the ``heading'' to ``yes''),
and name the resulting variable,
this time ``pennyData''
%
Don't forget to copy the resulting command into your script.
%
From here, we can begin using the data.

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Load pennyData}
\hlstd{pennyData} \hlkwb{<-} \hlkwd{read.csv}\hlstd{(}\hlstr{"data/pennyData.csv"}\hlstd{)}

\hlcom{## Display some of the data}
\hlstd{pennyData}\hlopt{\$}\hlstd{Penny.Ages}
\end{alltt}\end{kframe}\end{knitrout}


As you can see, there are 1000 penny ages in the data set,
but it is difficult to get a sense for what the data look like from 1000 numbers,
particularly if they weren't ordered.
%
A histogram is a great tool to display the shape of a dataset.
%
Here, we are going to search for the function within RStudio,
but you could easily type ``make histogram in R''
into Google for some more great examples. 
%
Search directly in R by using
``\verb;??histogram;'' at the command line.

Look through the resulting list,
to see if anything looks promising.
%
It seems that the function
``\verb;plot.histogram;'' might be useful.
%
Click on that and look at the resulting help document.
%
This doesn't look quite right,
but does point us to a function called ``\verb;hist;.''
%
Click on one of the links to ``\verb;hist;'' and browse through that help file.
%
That seems more like it.
%
Now, let's try using \verb;hist();:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Plot a histogram}
\hlkwd{hist}\hlstd{(pennyData}\hlopt{\$}\hlstd{Penny.Ages)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-26} 

}
\end{knitrout}


Does the data look normally distributed to your eye?
%
Add a comment to your script describing the graph and what it suggests about the distribution.
%
Now, let's try a plot that will give us a better idea about the normality:
the \verb;qqnorm(); function creates a plot with the observed data (y-axis, by default)\
against the expected values from a perfect normal distribution.

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Plot the qq-plot for penny ages}
\hlkwd{qqnorm}\hlstd{(pennyData}\hlopt{\$}\hlstd{Penny.Ages)}

\hlcom{# Add a line to observe deviation}
\hlkwd{qqline}\hlstd{(pennyData}\hlopt{\$}\hlstd{Penny.Ages,} \hlkwc{col}\hlstd{=}\hlstr{'red'}\hlstd{)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-27} 

}
\end{knitrout}



Does the data align very closely to the line?
%
Add a comment suggesting whether or not you think the data are normal based on this plot.
%
Note here that the argument ``\verb;col=;'' lets you set the color of the output.
%
This argument works for many plot functions,
and there are 657 named colors (type ``\verb;colors();'' for a list),
or can be specified with hexadecimal notation (e.g '\#FF0000'). 

For comparison, we can generate a random data set from the normal distribution,
and see what the plot looks like.
%
Try this:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Generate random data to see what a QQ-plot 'should' look like}
\hlcom{## generates 1000 random data points from the normal distribution}
\hlstd{randData} \hlkwb{<-} \hlkwd{rnorm}\hlstd{(}\hlnum{1000}\hlstd{)}

\hlkwd{qqnorm}\hlstd{(randData)}
\hlkwd{qqline}\hlstd{(randData,}\hlkwc{col}\hlstd{=}\hlstr{'red'}\hlstd{)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-28} 

}
\end{knitrout}


Use that graph as a baseline against which to assess your data.
You can use the ``Back'' button (left facing blue arrow)
above the plots to view previously created plots.
%
Update your comment as needed, given your new information.
%
In many cases,
this eye-ball approach is a great first approximation of the normality of your data.
%
However, R also has several built in normality tests, which we will explore in the next chapter.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Plotting correlations using hot dog data} %%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

We are now switching to another data set again,
this time a data set on the calories and sodium in various types of hotdogs,
originally collected by Consumer Reports in June 1986 (pp. 366-367).
%
These data are in the file ``hotdogs.csv''.
As before, put in a new separator (e.g. lots of ``\#''s)
to make it easy to find this section if needed.
%
Load the data as we have above (look back if you need to), and
name the data.frame ``hotdogs''.
%
Don't forget to copy the command into your script if you don't type it directly.


Next, lets play with a few more plotting options.
%
This time, we want to look at the relationship between sodium and calories.
%
So, try:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Plot relationship between Calories and Sodium}
\hlkwd{plot}\hlstd{(hotdogs}\hlopt{\$}\hlstd{Calories, hotdogs}\hlopt{\$}\hlstd{Sodium)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-30} 

}
\end{knitrout}


This plot works, but it is missing a title and information about units.
%
Use the plotting parameters from above (e.g., \verb;main, xlab, ylab;, etc)
to modify the plot to make it clearer.
%
Does it appear that sodium is related to calories?
%
Add a comment to your script.


What if, however, only some types of hot dogs show such a relationship?
%
We can color code the types of hot dogs to look at them separately.
%
The simplest way to do this is with the function \verb;points();,
which adds points to a graph.
%
Recall from earlier that ``[ ]'' calls specific elements from a vector,
and can be used with a logical test to limit which points are displayed.
%
Here, we will also use a different shape for the points that will be easier to see.
%
Look at the help for \verb;par; (\verb;?par;)
for more information about all graphing parameters, including \verb;pch;. 


\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Add color coded points for each type of hot dog}
\hlcom{## Feel free to use different colors, or use '?par' to look at other 'pch' options}
\hlcom{## the '==' tests to see if the values are identical}
\hlkwd{plot}\hlstd{(hotdogs}\hlopt{\$}\hlstd{Calories, hotdogs}\hlopt{\$}\hlstd{Sodium)}

\hlkwd{points}\hlstd{(hotdogs}\hlopt{\$}\hlstd{Calories[hotdogs}\hlopt{\$}\hlstd{Type}\hlopt{==}\hlstr{'Beef'}\hlstd{],}
       \hlstd{hotdogs}\hlopt{\$}\hlstd{Sodium[hotdogs}\hlopt{\$}\hlstd{Type}\hlopt{==}\hlstr{'Beef'}\hlstd{],} \hlkwc{pch}\hlstd{=}\hlnum{19}\hlstd{,}\hlkwc{col}\hlstd{=}\hlstr{'red'}\hlstd{)}

\hlkwd{points}\hlstd{(hotdogs}\hlopt{\$}\hlstd{Calories[hotdogs}\hlopt{\$}\hlstd{Type}\hlopt{==}\hlstr{'Poultry'}\hlstd{],}
       \hlstd{hotdogs}\hlopt{\$}\hlstd{Sodium[hotdogs}\hlopt{\$}\hlstd{Type}\hlopt{==}\hlstr{'Poultry'}\hlstd{],} \hlkwc{pch}\hlstd{=}\hlnum{19}\hlstd{,}\hlkwc{col}\hlstd{=}\hlstr{'yellow'}\hlstd{)}

\hlkwd{points}\hlstd{(hotdogs}\hlopt{\$}\hlstd{Calories[hotdogs}\hlopt{\$}\hlstd{Type}\hlopt{==}\hlstr{'Meat'}\hlstd{],}
       \hlstd{hotdogs}\hlopt{\$}\hlstd{Sodium[hotdogs}\hlopt{\$}\hlstd{Type}\hlopt{==}\hlstr{'Meat'}\hlstd{],} \hlkwc{pch}\hlstd{=}\hlnum{19}\hlstd{,}\hlkwc{col}\hlstd{=}\hlstr{'blue'}\hlstd{)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-31} 

}
\end{knitrout}


Now, each of the types is color-coded,
and we can interpret each.
%
Has your conclusion changed at all?
%
Add a comment to your script here.
%
Finally, we can add a legend to the plot with the function \verb;legend();.
%
Not that a legend can either be added by naming a position (e.g., top),
or by passing explicit x-y coordinates.
%
Here, we will use a named position,
but for finer control, the coordinates may work better for you.

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Add a legend}
\hlkwd{legend}(\hlstr{"bottomright"}, inset=.05,
       legend=\hlkwd{c}(\hlstr{'Beef'},\hlstr{'Poultry'},\hlstr{'Meat'}),
       fill=\hlkwd{c}(\hlstr{'red'}, \hlstr{'yellow'},\hlstr{'blue'}),title=\hlstr{'Type'})
\end{alltt}\end{kframe}\end{knitrout}


\begin{knitrout}
{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-33} 

}
\end{knitrout}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Bar plots and tables using violations data} %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Finally, we will work on a new type of plot in R: the bar plot.
%
For this, we will use the violations data set.
%
These data are a sample of the fines assessed to college students on a large college campus,
including the Year of the student (e.g., Freshman or Senior), and the amount of the fine.
%
The data are in the file ``violations.csv''

Load it as before.
Don't forget to copy the commands into your script,
if you use the file menu.
%
The year data is of the class (aka type) ``factor.''
%
This is a variable type that R uses to recognize that the data are grouping variables -- categories that separate data.
%
The values of these groups are by default stored alphabetically as the ``levels'' of the variable.
%
The first thing we want to do is change that order to something more useful for our purposes:



\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## See what kind of variable 'Year' is}
\hlkwd{class}\hlstd{(violations}\hlopt{\$}\hlstd{Year)}

\hlcom{## View the levels of the variable 'Year'}
\hlkwd{levels}\hlstd{(violations}\hlopt{\$}\hlstd{Year)}

\hlcom{## Set the levels of Year to the normal order}
\hlstd{violations}\hlopt{\$}\hlstd{Year} \hlkwb{<-} \hlkwd{factor}\hlstd{(violations}\hlopt{\$}\hlstd{Year,}\hlkwd{c}\hlstd{(}\hlstr{'Fr'}\hlstd{,}\hlstr{'So'}\hlstd{,}\hlstr{'Jr'}\hlstd{,}\hlstr{'Sr'}\hlstd{))}
\end{alltt}\end{kframe}\end{knitrout}


Now, lets look at a helpful summary of the data.
%
For this, we will use the function \verb;table(); in R.
\verb;table(); counts the number of times a given value occurs,
and produces and output that shows those counts.

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Produce a simple table, here showing the number from each class}
\hlkwd{table}\hlstd{(violations}\hlopt{\$}\hlstd{Year)}

\hlcom{## Save and display a more useful table}
\hlstd{violationsTable} \hlkwb{<-} \hlkwd{table}\hlstd{(violations}\hlopt{\$}\hlstd{Fine,violations}\hlopt{\$}\hlstd{Year)}
\hlstd{violationsTable}
\end{alltt}\end{kframe}\end{knitrout}


This table shows the number of fines of each value given to each class in the dataset. Such a table can then be used for a large number of other R functions, including plotting using barplot(). A simple example is just to call:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Make a simple bar plot of vioations}
\hlkwd{barplot}\hlstd{(violationsTable)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-37} 

}
\end{knitrout}


This simple plot can give us a good first look at the data,
but we can make it more beautiful (one of the powers of R).

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Set some colors to use, Juniata colors seemed fitting}
\hlstd{barColors} \hlkwb{<-} \hlkwd{c}\hlstd{(}\hlstr{'blue'}\hlstd{,}\hlstr{'gold3'}\hlstd{,}\hlstr{'white'}\hlstd{,}\hlstr{'grey'}\hlstd{)}

\hlcom{## Use the bar colors, and add a title to the graph}
\hlkwd{barplot}\hlstd{(violationsTable,} \hlkwc{col}\hlstd{=barColors,} \hlkwc{main}\hlstd{=}\hlstr{'Plot of Fines by Year'}\hlstd{)}

\hlcom{## Add a legend}
\hlkwd{legend}\hlstd{(}\hlstr{"bottomright"}\hlstd{,}\hlkwc{inset}\hlstd{=}\hlnum{0.05}\hlstd{,}
       \hlkwc{legend}\hlstd{=}\hlkwd{rownames}\hlstd{(violationsTable),}\hlkwc{fill}\hlstd{=barColors,}\hlkwc{bg}\hlstd{=}\hlstr{"white"}\hlstd{)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-38} 

}
\end{knitrout}


In addition, the \verb;barplot(); function allows us to show the data next to each other,
rather than stacked.
%
This allows each of the fine values to be compared more easily,
and may be more useful, depending on your purposes.

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Create a plot with the values side-by-side}
\hlkwd{barplot}\hlstd{(violationsTable,} \hlkwc{beside}\hlstd{=}\hlnum{TRUE}\hlstd{,} \hlkwc{col}\hlstd{=barColors,} \hlkwc{main}\hlstd{=}\hlstr{'Plot of Fines by Year'}\hlstd{)}

\hlcom{## Add a legend}
\hlkwd{legend}\hlstd{(}\hlstr{"topright"}\hlstd{,}\hlkwc{inset}\hlstd{=}\hlnum{0.05}\hlstd{,}
       \hlkwc{legend}\hlstd{=}\hlkwd{rownames}\hlstd{(violationsTable),}\hlkwc{fill}\hlstd{=barColors,}\hlkwc{bg}\hlstd{=}\hlstr{"white"}\hlstd{)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-39} 

}
\end{knitrout}


Finally, tables can be rotated to allow us to look at the data in a different way.
%
This uses the function \verb;t();, which transposes any table or matrix.

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlcom{## Display the rotated table}
\hlkwd{t}\hlstd{(violationsTable)}

\hlcom{## Make a plot of the transposed table}
\hlkwd{barplot}\hlstd{(}\hlkwd{t}\hlstd{(violationsTable),}\hlkwc{col}\hlstd{=barColors,}
        \hlkwc{beside}\hlstd{=}\hlnum{TRUE}\hlstd{,}\hlkwc{main}\hlstd{=}\hlstr{'Plot of fines by cost'}\hlstd{)}

\hlcom{## Add a legend}
\hlkwd{legend}\hlstd{(}\hlstr{"topright"}\hlstd{,}\hlkwc{inset}\hlstd{=}\hlnum{0.05}\hlstd{,}
       \hlkwc{legend}\hlstd{=}\hlkwd{rownames}\hlstd{(violationsTable),}\hlkwc{fill}\hlstd{=barColors,}\hlkwc{bg}\hlstd{=}\hlstr{"white"}\hlstd{)}
\end{alltt}\end{kframe}

{\centering \includegraphics[width=.4\linewidth]{figure/plotInR-unnamed-chunk-40} 

}
\end{knitrout}


As you have hopefully seen, R has an incredible amount of power.
%
In this chapter,
we have focused largely on importing data and displaying it.
%
In the future, use these notes, and the script you generated as a starting point for your analyses.
%
Google is your friend (GIYF) as you move forward and add additional approaches and statistical tests.

%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Assignment} %%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%

For your assignment, create
an html output from the script to confirm that your code worked.
%
Even if you are not doing this tutorial for a class,
generating this file will allow you to check your own work,
and will catch most common mistakes.
%
RStudio has a built in tool to generate these files,
but it requires an R package called knitr.
%
Install the knitr package from the command line,
not in your script using:

\begin{knitrout}\begin{kframe}\begin{alltt}
\hlkwd{install.packages}\hlstd{(}\hlstr{'knitr'}\hlstd{)}
\end{alltt}\end{kframe}\end{knitrout}

\ldots and follow the on screen prompts.


Now, click on the small notebook icon just above your script.
%
It should say ``Compile an HTML notebook from the current R script''
when you mouse over it.
%
Assign an appropriate title,
and put your name as the author.
%
Click ``Compile'' and an html file will be created.
%
Submit these as instructed for the course
%
% If you run into problems as you work on this,
% email me with as much detail as possible about the problem.

% \end{document}
